/****************************************************************************
*   Copyright 1999, Caldera Thin Client Systems, Inc.                       *
*   This software is licensed under the GNU Public License.                 *
*   See LICENSE.TXT for further information.                                *
*                                                                           *
*   Historical Copyright                                                    *
*                                                                           *
*   Copyright (c) 1985,1991  Digital Research Inc.  All rights reserved.    *
*   The Software Code contained in this listing is proprietary to Digital   *
*   Research Inc., Monterey, California, and is covered by U.S. and other   *
*   copyright protection.  Unauthorized copying, adaption, distribution,    *
*   use or display is prohibited and may be subject to civil and criminal   *
*   penalties.  Disclosure to others is prohibited.  For the terms and      *
*   conditions of software code use, refer to the appropriate Digital       *
*   Research License Agreement.						    *
*****************************************************************************
*		      U.S. GOVERNMENT RESTRICTED RIGHTS			    *
*                    ---------------------------------                      *
*  This software product is provided with RESTRICTED RIGHTS.  Use, 	    *
*  duplication or disclosure by the Government is subject to restrictions   *
*  as set forth in FAR 52.227-19 (c) (2) (June, 1987) when applicable or    *
*  the applicable provisions of the DOD FAR supplement 252.227-7013 	    *
*  subdivision (b)(3)(ii) (May 1981) or subdivision (c)(1)(ii) (May 1987).  *
*  Contractor/manufacturer is Digital Research Inc. / 70 Garden Court /     *
*  BOX DRI / Monterey, CA 93940.					    *
*****************************************************************************
* $Header: m:/davinci/users//groups/panther/dsk/rcs/deskkeys.h 3.2 92/02/04 16:14:52 sbc Exp $
* $Log:	deskkeys.h $
 * Revision 3.2  92/02/04  16:14:52  sbc
 * remove defs of "UP", "DOWN", "LEFT", "RIGHT". Replace with refs to "CURS_UP"
 * "CURS_DN", etc from desktop.c.
 * 
 * Revision 3.1  91/08/19  16:32:04  system
 * ViewMAX 2 sources
 * 
 * Revision 3.4  91/06/04  13:05:14  sbc
 * misc housekeeping and other ravings...
 * 
 * Revision 3.3  91/05/22  13:08:48  fontes
 * C-E Tree, completed implementation
 * 
 * Revision 3.2  91/05/20  16:54:39  fontes
 * C-E trees: tag managment completed
 * 
 * Revision 3.1  91/05/16  14:47:16  fontes
 * Separate branch for Beta bug fixes, separate from split-mode windows
 * 
 * Revision 2.1  91/04/24  10:52:53  fontes
 * Add as new module
 * 
* 
*****************************************************************************/

/****************************************************************************
* File:		deskkeys.h
*
* Description:	
*
* Build Info:	ndmake -f vm2.mak
*
* Overview:	
*  
*****************************************************************************/

/* Keyboard characters */


#define	ALT_0		0x8100
#define ALT_1		0x7800
#define ALT_2  		0x7900
#define ALT_3  		0x7A00
#define ALT_4  		0x7B00
#define ALT_5  		0x7B00
#define ALT_6  		0x7D00
#define ALT_7  		0x7E00
#define ALT_8  		0x7F00
#define ALT_9  		0x8000
#define ALT_A  		0x1E00
#define ALT_B  		0x3000
#define ALT_C  		0x2E00
#define ALT_D  		0x2000
#define ALT_E  		0x1200
#define ALT_F  		0x2100
#define ALT_G  		0x2200
#define ALT_H  		0x2300
#define ALT_I  		0x1700
#define ALT_J  		0x2400
#define ALT_K  		0x2500
#define ALT_L  		0x2600
#define ALT_M  		0x3200
#define ALT_N  		0x3100
#define ALT_O  		0x1800
#define ALT_P  		0x1900
#define ALT_Q  		0x1000
#define ALT_R  		0x1300
#define ALT_S  		0x1F00
#define ALT_T  		0x1400
#define ALT_U  		0x1600
#define ALT_V  		0x2F00
#define ALT_W  		0x1100
#define ALT_X  		0x2D00
#define ALT_Y  		0x1500
#define ALT_Z  		0x2C00

#define ALT_F4		0x6B00
#define ALT_F5		0x6C00

#define ALT_PLUS_EQUAL	0x8300	/*Alt-+ and Alt= are the same*/
#define	ALT_MINUS	0x8200

#define CTL_D		0x2004
#define CTL_E		0x1205
#define CTL_Q		0x1011
#define	CTL_S		0x1f13
#define CTL_U		0x1615
#define CTL_X		0x2d18

#define CTL_UP		0x0	
#define CTL_DN		0x1
#define CTL_LF		0x7300
#define CTL_RT		0x7400
#define CTL_P_UP	0x8400
#define CTL_P_DOWN	0x7600

#define CTL_BACKSPACE	0x0E7F

#define CURS_UP 	0x4800
#define CURS_DN 	0x5000
#define CURS_LF 	0x4B00
#define CURS_RT 	0x4D00

#define F0		0x4400
#define F1		0x3b00
#define F5		0x3f00

#define P_DOWN 		0x5100
#define P_UP   		0x4900
#define HOME  		0x4700
#define ESC		0x011B
#define END		0x4F00	
#define ENTER		0x1C0D
#define SPACE		0x3920
#define TAB		0x0F09
#define SHFT_DEL	0x5300
#define BACKSPACE 	0x0E08
#define DELETE 		0x5300
#define BACKTAB 	0x0F00
#define RETURN 		0x1C0D
#define PLUS		0x0D2B
#define MINUS		0x0C2D
#define NP_PLUS		0x4E2B
#define NP_MINUS	0x4A2D

/* end of deskkeys.h */
